import java.util.*;
import java.io.*;

public class ApproxInference extends Inference {
    
    public Random _r;
    
    public ApproxInference(Node[] ns,int doDebug) {
	super(ns,doDebug);
	//seed the random number generator with the current time
	_r = new Random(System.currentTimeMillis());
    }//constructor
    
    public void gibbs(String query, String evidence, int numIterations) 
    {
    }//Gibbs Sampling
    
    
    
    
    
    public void likelihoodWeighting(String query, String evidence, int numIterations) {
    }//LikelihoodWeighting




    public void rejectionSampling(String query, String evidence, int numIterations) {
    }//rejectionSampling

    //verifies that all the variables and their instantiations found in r
    //are the same as those in f
    public boolean checkConsistency(Vector f, String r) {
	Hashtable h = makeHashtableOfStrRep(r);
	Enumeration e = h.keys();

	while (e.hasMoreElements()) {
	    String key = (String)e.nextElement();
	    String inst = findInstantiation(f,key);
	    if (!inst.equals(h.get(key))) return false;
	}//while
	return true;
    }//consistentWithEvidence

    /*******************************************************************************/
    /**** Method probabilityVariableIsTrue - find the probability that variable ****/
    /**** is true fiven it's parents which we assume are instantiated. This     ****/
    /**** condition should be verified with a call to readyForInstantiation     ****/
    public double probabilityVariableIsTrue(String variable, Vector f) {
	String[] parents = getParents(variable);
	if (parents.length == 0)
	    return findProbInGlobalCPT(variable+_TRUE);
	
	String instantiatedRep = variable+_TRUE+"|";

	for (int i=0; i<parents.length; i++) {
	    String inst = findInstantiation(f,parents[i]);

	    instantiatedRep = instantiatedRep.concat(parents[i]+inst);
	    if (i+1 < parents.length)
		instantiatedRep = instantiatedRep.concat("&");
	}
	if (DEBUG==1)
	    System.out.println("probabilityVariablesIsTrue: P("+instantiatedRep+") = "+findProbInGlobalCPT(instantiatedRep));

	return findProbInGlobalCPT(instantiatedRep);
    }//probabilityVariableIsTrue

    /**********************************************************************/
    /**** Method readyForInstantiation - var is ready for instantiation****/
    /**** only if all it's parents are instantiated                    ****/
    public boolean readyForInstantiation(String var, Vector _F) {
	String[] parents = getParents(var);
	if (parents.length == 0) 
	    return true;

	Vector uninstantiated = countUninstantiated(_F,var);

	for (int i=0; i<parents.length; i++) {
	    Enumeration e = uninstantiated.elements();
	    while (e.hasMoreElements())
		if (parents[i].equals((String)e.nextElement()))
		    return false;
	}//for
	return true;
    }//readyForInstantiation

    public int pickRandomNodeIndex(int numNodes) {
        return _r.nextInt(numNodes);
    }
    

    public String rollDie(double probabilityTrue) {
	if (_r.nextDouble() < probabilityTrue) return _TRUE;
	return _FALSE;
    }

}//class
